Index: theme/metal/colors.css
===================================================================
RCS file: /cvsroot/moodle/moodle/theme/metal/colors.css,v
retrieving revision 1.5
diff -u -r1.5 colors.css
--- theme/metal/colors.css	19 Mar 2007 23:59:02 -0000	1.5
+++ theme/metal/colors.css	19 Dec 2007 11:27:13 -0000
@@ -242,14 +242,6 @@
 
 .sideblock .list {
 }
-.sideblock .header .hide-show img.hide-show-image {
-  background: url('../../pix/t/switch_minus.gif') no-repeat bottom;
-}
-
-.sideblock.hidden .header .hide-show img.hide-show-image {
-  background: url('../../pix/t/switch_plus.gif') no-repeat bottom;
-}
-
 
 
 /***
Index: theme/orangewhite/styles_layout.css
===================================================================
RCS file: /cvsroot/moodle/moodle/theme/orangewhite/styles_layout.css,v
retrieving revision 1.41
diff -u -r1.41 styles_layout.css
--- theme/orangewhite/styles_layout.css	2 Feb 2007 14:44:27 -0000	1.41
+++ theme/orangewhite/styles_layout.css	19 Dec 2007 11:27:14 -0000
@@ -219,7 +219,7 @@
 .sideblock .searchform {
   text-align:left
 }
-.sideblock .header .hide-show img.hide-show-image {
+.sideblock .header .hide-show-image {
   margin-top:0.1em;
 }
 .sideblock .searchform a {
Index: theme/orangewhite/styles_color.css
===================================================================
RCS file: /cvsroot/moodle/moodle/theme/orangewhite/styles_color.css,v
retrieving revision 1.33
diff -u -r1.33 styles_color.css
--- theme/orangewhite/styles_color.css	19 Mar 2007 23:59:07 -0000	1.33
+++ theme/orangewhite/styles_color.css	19 Dec 2007 11:27:14 -0000
@@ -255,10 +255,10 @@
 }
 .sideblock .list {
 }
-.sideblock .header .hide-show img.hide-show-image {
+.sideblock .header .hide-show-image {
   background:url('pix/switch_minus.gif') no-repeat bottom
 }
-.sideblock.hidden .header .hide-show img.hide-show-image {
+.sideblock.hidden .header .hide-show-image {
   background:url('pix/switch_plus.gif') no-repeat bottom
 }
 #left-column .sideblock .header {
Index: pix/t/switch_plus.gif
===================================================================
RCS file: /cvsroot/moodle/moodle/pix/t/switch_plus.gif,v
retrieving revision 1.2
diff -u -r1.2 switch_plus.gif
Binary files /tmp/cvs4kqNE6 and switch_plus.gif differ
Index: pix/t/switch_minus.gif
===================================================================
RCS file: /cvsroot/moodle/moodle/pix/t/switch_minus.gif,v
retrieving revision 1.2
diff -u -r1.2 switch_minus.gif
Binary files /tmp/cvsxIPNql and switch_minus.gif differ
Index: theme/chameleon/user_styles.css
===================================================================
RCS file: /cvsroot/moodle/moodle/theme/chameleon/user_styles.css,v
retrieving revision 1.10
diff -u -r1.10 user_styles.css
--- theme/chameleon/user_styles.css	6 Aug 2007 19:39:08 -0000	1.10
+++ theme/chameleon/user_styles.css	19 Dec 2007 11:27:13 -0000
@@ -237,14 +237,10 @@
 .sideblock .content .message {
   text-align: left;
 }
-.sideblock .header .hide-show img.hide-show-image {
-  background-image: url(../../pix/t/switch_minus.gif);
-  background-repeat: no-repeat;
+.sideblock .header .hide-show-image {
   margin-top: 0;
 }
-.sideblock.hidden .header .hide-show img.hide-show-image {
-  background-image: url(../../pix/t/switch_plus.gif);
-  background-repeat: no-repeat;
+.sideblock.hidden .header .hide-show-image {
   margin-top: 2px;
 }
 #calendar .event_global {
Index: theme/formal_white/fw_color.css
===================================================================
RCS file: /cvsroot/moodle/moodle/theme/formal_white/fw_color.css,v
retrieving revision 1.18
diff -u -r1.18 fw_color.css
--- theme/formal_white/fw_color.css	15 Jun 2007 13:39:56 -0000	1.18
+++ theme/formal_white/fw_color.css	19 Dec 2007 11:27:13 -0000
@@ -153,14 +153,6 @@
   border-top-color:#C6BDA8;
 }
 
-.sideblock .header .hide-show img.hide-show-image {
-  background: url('../../pix/t/switch_minus.gif') no-repeat bottom;
-}
-
-.sideblock.hidden .header .hide-show img.hide-show-image {
-  background: url('../../pix/t/switch_plus.gif') no-repeat bottom;
-}
-
 .sideblock .content .post .head .date,
 .sideblock .content .post .head .name {
   color: #000000;
Index: theme/wood/styles_color.css
===================================================================
RCS file: /cvsroot/moodle/moodle/theme/wood/styles_color.css,v
retrieving revision 1.39
diff -u -r1.39 styles_color.css
--- theme/wood/styles_color.css	20 Nov 2007 00:10:05 -0000	1.39
+++ theme/wood/styles_color.css	19 Dec 2007 11:27:14 -0000
@@ -25,7 +25,7 @@
 .sideblock .r1,
 .generaltable .cell,
 div.sideblock table.minicalendar,
-.sideblock .hide-show a {
+.sideblock .hide-show-image {
     border:none;
     background:none;
 }
@@ -182,11 +182,11 @@
   border-bottom-color:#330000;
 }
 
-.sideblock .header .hide-show img.hide-show-image {
+.sideblock .header .hide-show-image {
   background: url('pix/t/switch_minus.gif') no-repeat bottom;
 }
 
-.sideblock.hidden .header .hide-show img.hide-show-image {
+.sideblock.hidden .header .hide-show-image {
   background: url('pix/t/switch_plus.gif') no-repeat bottom;
 }
 
Index: theme/custom_corners/user_styles.css
===================================================================
RCS file: /cvsroot/moodle/moodle/theme/custom_corners/user_styles.css,v
retrieving revision 1.27
diff -u -r1.27 user_styles.css
--- theme/custom_corners/user_styles.css	16 Dec 2007 09:41:56 -0000	1.27
+++ theme/custom_corners/user_styles.css	19 Dec 2007 11:27:13 -0000
@@ -274,14 +274,7 @@
 div.sideblock div.content div.message {
   text-align: left;
 }
-div.sideblock div.header div.hide-show img.hide-show-image {
-  background-image: url(../../pix/t/switch_minus.gif);
-  background-repeat: no-repeat;
-  margin-top: 0;
-}
-div.sideblock.hidden div.header div.hide-show img.hide-show-image {
-  background-image: url(../../pix/t/switch_plus.gif);
-  background-repeat: no-repeat;
+.sideblock .header .hide-show-image {
   margin-top: 0;
 }
 table#calendar td.event_global {
@@ -1239,4 +1232,4 @@
 #admin-roles-manage .rolecap .cap-desc .cap-name,
 #admin-roles-override .rolecap .cap-desc .cap-name {
   color: #888;
-}
+}
\ No newline at end of file
Index: theme/oceanblue/styles_color.css
===================================================================
RCS file: /cvsroot/moodle/moodle/theme/oceanblue/styles_color.css,v
retrieving revision 1.58
diff -u -r1.58 styles_color.css
--- theme/oceanblue/styles_color.css	12 Nov 2007 17:56:07 -0000	1.58
+++ theme/oceanblue/styles_color.css	19 Dec 2007 11:27:14 -0000
@@ -410,19 +410,6 @@
   border-bottom-color: #dddddd;
 }
 
-.sideblock .header .hide-show img.hide-show-image {
-  background: url('../../pix/t/switch_minus.gif') no-repeat bottom;
-}
-
-.sideblock.hidden .header .hide-show img.hide-show-image {
-  background: url('../../pix/t/switch_plus.gif') no-repeat bottom;
-}
-
-/* Accessibility: for Windows High Contrast, partial fix MDL-7493. */
-.sideblock .hide-show a {
-  border:1px solid white;
-}
-
 /***
  *** Blogs
  ***/